c-------------
      subroutine fillvfngrid
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      INCLUDE 'APSCOM5.'
      INCLUDE 'CONSTCOM.'

      COMMON  /FORQGSPL/ XB0,Q2,XLOG,AN,AN2,an3,kn,iqn,ixn,isn

      do is=-nsmgrid,nspgrid
        Q2=0.04*exp(exp(sgrid(is))*log(q2ini/0.04))
        AN=ALPHAS_ffn4(q2)/4./PI 
        an2=an**2
c  generation of the LO 4-flavour PDFs
        call fillvfx(is,8,0)
c  generation of the NLO 4-flavour PDFs
        if (kordhq.ge.1) call fillvfx(is,8,1)
      end do

      return 
      end
c-------------
      subroutine fillvfx(is,nhq,kome)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      INCLUDE 'APSCOM5.'
      INCLUDE 'CONSTCOM.'

      COMMON  /FORQGSPL/ XB0,Q2,XLOG,AN,AN2,an3,kn,iqn,ixn,isn

      real*8 fsp(nxtot),bs(nxtot),cs(nxtot),ds(nxtot),xx(nxtot)

      do ix=-nxmgrid,nxpgrid
        xx(ix+nxmgrid+1)=xgrid(ix)
      end do

      DO IX=-nxmgrid,nxpgrid-1
        do iq=1,nhq
          Y(kome+1,iq,IX,is)=hqpdf(XGRID(IX),is,iq,nhq,kome)
        end do 
        Y(kome+1,nhq+1,IX,is)=Y(kome+1,nhq,IX,is)
      end do
      do iq=1,nhq+1
        Y(kome+1,IQ,nxpgrid,is)=0D0
        do ix=-nxmgrid,nxpgrid
          fsp(ix+nxmgrid+1)=y(kome+1,iq,ix,is)
        end do
        call spline (nxmgrid+nxpgrid+1,xx,fsp,bs,cs,ds)
        do ix=-nxmgrid,nxpgrid
          bcoeff(kome+1,iq,ix,is)=bs(ix+nxmgrid+1)
          ccoeff(kome+1,iq,ix,is)=cs(ix+nxmgrid+1)
          dcoeff(kome+1,iq,ix,is)=ds(ix+nxmgrid+1)
        end do
      end do

      return 
      end
C------------------
      real*8 function hqpdf(xb,is,iq,ihq,kome)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      INCLUDE 'APSCOM5.'
      include 'CONSTCOM.'

c parameter defining the integration accuracy
      data nf2hq /1/

      COMMON  /FORQGSPL/ XB0,Q2,XLOG,AN,AN2,an3,kn,iqn,ixn,isn
      common /forhqpdf/ r,kome0
      real*8 q(nflim)

      external hqpdfi1,hqpdfi2

      xb0=xb
      iqn=iq
      isn=is
      kn=(ihq-8)/2
      kome0=kome
      r=q2/rmass(ihq)**2  

      hqpdf=0.

c local terms for the gluon and quark pieces

      if (iq.eq.1) then 
        hqpdf=1 + an*ome_gg_1_local(xb,r)
        if (kome.ge.1) hqpdf=hqpdf + an2*ome_gg_2_local(xb,r)
        hqpdf=hqpdf*XQGX1(kn,1,XB,IS)
      end if

      if (iq.ge.2.and.iq.le.7+2*kn) then 
        hqpdf=1
        if (kome.ge.1) hqpdf=hqpdf + an2*ome_qqns_2_local(xb,r)
        hqpdf=hqpdf*XQGX1(kn,iq,XB,IS)
      end if

c  integration of the total regular term 

        CALL GAUSS1(hqpdfi2,log(xb)
     ,            ,(0d0),nf2hq,res,EPS2)

      hqpdf=hqpdf+res

      return 
      end
C------------------
      real*8 function hqpdfi1(t)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      y=1.-exp(t)

      hqpdfi1=hqpdfi(y)*(1-y)

      return 
      end
C------------------
      real*8 function hqpdfi2(t)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      y=exp(t)

      hqpdfi2=hqpdfi(y)*y

      return 
      end
C------------------
      real*8 function hqpdfi(z)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      include 'CONSTCOM.'
      real*8 q(13)

      COMMON  /FORQGSPL/ XB0,Q2,XLOG,AN,AN2,an3,kn,iqn,ixn,isn
      common /forhqpdf/ r,kome0

      y=xb0/z
      hqpdfi=0.

c   gluon distribution 

      if (iqn.eq.1) then 
        if (kome0.ge.1) then 
          glu0=xqgx1(kn,1,xb0,isn)
          glu=xqgx1(kn,1,y,isn)
          hqpdfi=hqpdfi+ome_gg_2_singular(z,r)*(glu-glu0)
          hqpdfi=hqpdfi+ome_gg_2(z,r)*glu
          qps=0.
          do k=2,7+2*kn
            qps=qps+xqgx1(kn,k,y,isn)
          end do
          hqpdfi=hqpdfi+ome_gq_2(z,r)*qps
          hqpdfi=hqpdfi*an2
        end if
      end if

c  light quark disributions

      if (iqn.ge.2.and.iqn.le.7+2*kn) then 
        if (kome0.ge.1) then 
          pdf0=xqgx1(kn,iqn,xb0,isn)
          pdfc=xqgx1(kn,iqn,y,isn)
          hqpdfi=hqpdfi+ome_qqns_2_singular(z,r)*(pdfc-pdf0)
          hqpdfi=hqpdfi+ome_qqns_2(z,r)*pdfc
          hqpdfi=hqpdfi*an2
        end if
      end if

c  heavy quark distributions

      if (iqn.ge.8+2*kn) then 
        glu=xqgx1(kn,1,y,isn)
        hqpdfi=hqpdfi+ome_g_1(z,r)*an*glu
        if (kome0.ge.1) then 
          qps=0.
          do k=2,7+2*kn
            qps=qps+xqgx1(kn,k,y,isn)
          end do
          hqpdfi=hqpdfi + an2*(ome_g_2(z,r)*glu + ome_q_2(z,r)*qps)
        end if
        hqpdfi=hqpdfi/2.
      end if

      return 
      end
